Codeforces Round #369 (Div. 2) 711D Directed Roads (dfs)

来源:互联网 发布:淘宝人肉一个人多钱 编辑:程序博客网 时间:2024/05/21 22:35

D. Directed Roads
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

ZS the Coder and Chris the Baboon has explored Udayland for quite some time. They realize that it consists of n towns numbered from 1 to n.

There are n directed roads in the Udayland. i-th of them goes from town i to some other town ai (ai ≠ i). ZS the Coder can flip the direction of any road in Udayland, i.e. if it goes from town A to town B before the flip, it will go from town B to town A after.

ZS the Coder considers the roads in the Udayland confusing, if there is a sequence of distinct towns A1, A2, …, Ak (k > 1) such that for every 1 ≤ i < k there is a road from town Ai to town Ai + 1 and another road from town Ak to town A1. In other words, the roads are confusing if some of them form a directed cycle of some towns.

Now ZS the Coder wonders how many sets of roads (there are 2n variants) in initial configuration can he choose to flip such that after flipping each road in the set exactly once, the resulting network will not be confusing.

Note that it is allowed that after the flipping there are more than one directed road from some town and possibly some towns with no roads leading out of it, or multiple roads between any pair of cities.

Input

The first line of the input contains single integer n (2 ≤ n ≤ 2·105) — the number of towns in Udayland.

The next line contains n integers a1, a2, …, an (1 ≤ ai ≤ n, ai ≠ i), ai denotes a road going from town i to town ai.

Output

Print a single integer — the number of ways to flip some set of the roads so that the resulting whole set of all roads is not confusing. Since this number may be too large, print the answer modulo 109 + 7.

Examples
Input
3
2 3 1
Output
6
Input
4
2 1 1 1
Output
8
Input
5
2 4 2 5 3
Output
28

题解:
这道题要求能使这个图不存在环的方法种数,这个方法是你可以任意反转边,那么我们先找到环,然后只有两种情况下反转边不能消除环
1、全部反转 2、一条也不反转
其余情况都是可以消除环的,那么我们统计就好了。
注意要处理
3
2 1 1
这种环,在dfs的时候如果直接判断当前节点如果等于父节点就continue掉的话,会出错。需要使用技巧处理。
这道题求环的方法是通过深度来解决的,并用used数组标记是否访问过,这种方法值得学习一下。

#include<bits/stdc++.h>using namespace std;const int maxn=2e5+5;const __int64 mod=(__int64)(1e9+7);int n,cycle;__int64 Pow2[maxn];vector<pair<int,int> > G[maxn];bool used[maxn];int dep[maxn];void dfs(int now,int f,int d) {    if(used[now]) {        if(!cycle)            cycle=d-dep[now];        return;    }    dep[now]=d;    used[now]=true;    int len=(int)G[now].size();    for(int i=0; i<len; ++i) {        int from=G[now][i].first,to=G[now][i].second;        if(from^f) {            dfs(to,from,d+1);//为什么是from,而不是now,因为上面的判断是from不等于f,而且每一次的from值都是取自G[now][i].first        }    }}int main() {#ifdef tangge    freopen("D.in","r",stdin);#endif // tangge    int val;    Pow2[0]=1;    for(int i=1; i<maxn; ++i) {        Pow2[i]=(Pow2[i-1]<<1)%mod;    }    while(~scanf("%d",&n)) {        for(int i=0; i<=n; ++i) {            G[i].clear();        }        for(int i=1; i<=n; ++i) {            scanf("%d",&val);            G[i].push_back(make_pair(i,val));            G[val].push_back(make_pair(i,i));        }        memset(used,false,sizeof(used));        __int64 nums=0,ans=1;        for(int i=1; i<=n; ++i) {            if(!used[i]) {                cycle=0;                dfs(i,-1,0);                ans=ans*(Pow2[cycle]-2)%mod;                nums+=cycle;            }        }        ans=ans*(Pow2[n-nums])%mod;        cout<<ans<<endl;    }    return 0;}
0 0
原创粉丝点击